/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Contents of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.105 - (show annotations) (download)
Sun Jan 22 17:51:27 2006 UTC (8 years, 11 months ago) by kevquinn
Branch: MAIN
Changes since 1.104: +91 -65 lines
Reworked filter-flags to be more consistent; factored out common code
to _filter-var()

1 # Copyright 1999-2005 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.104 2006/01/14 10:52:12 kevquinn Exp $
4
5
6 # need access to emktemp()
7 inherit eutils toolchain-funcs multilib
8
9 #
10 #### filter-flags <flags> ####
11 # Remove particular flags from C[XX]FLAGS
12 # Matches only complete flags
13 #
14 #### append-flags <flags> ####
15 # Add extra flags to your current C[XX]FLAGS
16 #
17 #### replace-flags <orig.flag> <new.flag> ###
18 # Replace a flag by another one
19 #
20 #### replace-cpu-flags <old.cpus> <new.cpu> ###
21 # Replace march/mcpu flags that specify <old.cpus>
22 # with flags that specify <new.cpu>
23 #
24 #### is-flag[q] <flag> ####
25 # Returns "true" if flag is set in C[XX]FLAGS
26 # Matches only complete a flag
27 # q version sets return code but doesn't echo
28 #
29 #### is-ldflag[q] <flag> ####
30 # Returns "true" if flag is set in LDFLAGS
31 # Matches only complete a flag
32 # q version sets return code but doesn't echo
33 #
34 #### strip-flags ####
35 # Strip C[XX]FLAGS of everything except known
36 # good options.
37 #
38 #### strip-unsupported-flags ####
39 # Strip C[XX]FLAGS of any flags not supported by
40 # installed version of gcc
41 #
42 #### get-flag <flag> ####
43 # Find and echo the value for a particular flag
44 #
45 #### replace-sparc64-flags ####
46 # Sets mcpu to v8 and uses the original value
47 # as mtune if none specified.
48 #
49 #### filter-mfpmath <math types> ####
50 # Remove specified math types from the fpmath specification
51 # If the user has -mfpmath=sse,386, running `filter-mfpmath sse`
52 # will leave the user with -mfpmath=386
53 #
54 #### append-ldflags ####
55 # Add extra flags to your current LDFLAGS
56 #
57 #### filter-ldflags <flags> ####
58 # Remove particular flags from LDFLAGS
59 # Matches only complete flags
60 #
61 #### bindnow-flags ####
62 # Returns the flags to enable "now" binding in the current selected linker.
63 #
64 ################ DEPRECATED functions ################
65 # The following are still present to avoid breaking existing
66 # code more than necessary; however they are deprecated. Please
67 # use gcc-specs-* from toolchain-funcs.eclass instead, if you
68 # need to know which hardened techs are active in the compiler.
69 # See bug #100974
70 #
71 #### has_hardened ####
72 # Returns true if the compiler has 'Hardened' in its version string,
73 # (note; switched-spec vanilla compilers satisfy this condition) or
74 # the specs file name contains 'hardened'.
75 #
76 #### has_pie ####
77 # Returns true if the compiler by default or with current CFLAGS
78 # builds position-independent code.
79 #
80 #### has_pic ####
81 # Returns true if the compiler by default or with current CFLAGS
82 # builds position-independent code.
83 #
84 #### has_ssp_all ####
85 # Returns true if the compiler by default or with current CFLAGS
86 # generates stack smash protections for all functions
87 #
88 #### has_ssp ####
89 # Returns true if the compiler by default or with current CFLAGS
90 # generates stack smash protections for most vulnerable functions
91 #
92
93 # C[XX]FLAGS that we allow in strip-flags
94 setup-allowed-flags() {
95 if [[ -z ${ALLOWED_FLAGS} ]] ; then
96 export ALLOWED_FLAGS="-pipe"
97 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune"
98 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all"
99 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking -fno-bounds-checking"
100 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time"
101 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g0 -g1 -g2 -g3 -ggdb -ggdb0 -ggdb1 -ggdb2 -ggdb3"
102 fi
103 # allow a bunch of flags that negate features / control ABI
104 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all"
105 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \
106 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \
107 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \
108 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
109 -mieee -mieee-with-inexact \
110 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \
111 -mflat -mno-flat -mno-faster-structs -mfaster-structs \
112 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \
113 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias"
114
115 # C[XX]FLAGS that we are think is ok, but needs testing
116 # NOTE: currently -Os have issues with gcc3 and K6* arch's
117 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks -fprefetch-loop-arrays"
118 return 0
119 }
120
121 # inverted filters for hardened compiler. This is trying to unpick
122 # the hardened compiler defaults.
123 _filter-hardened() {
124 local f
125 for f in "$@" ; do
126 case "${f}" in
127 # Ideally we should only concern ourselves with PIE flags,
128 # not -fPIC or -fpic, but too many places filter -fPIC without
129 # thinking about -fPIE.
130 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
131 gcc-specs-pie || continue
132 is-flagq -nopie || append-flags -nopie;;
133 -fstack-protector)
134 gcc-specs-ssp || continue
135 is-flagq -fno-stack-protector || append-flags -fno-stack-protector;;
136 -fstack-protector-all)
137 gcc-specs-ssp-to-all || continue
138 is-flagq -fno-stack-protector-all || append-flags -fno-stack-protector-all;;
139 esac
140 done
141 }
142
143 # Remove occurrences of strings from variable given in $1
144 # Strings removed are matched as globs, so for example
145 # '-O*' would remove -O1, -O2 etc.
146 _filter-var() {
147 local f x VAR VAL
148 declare -a new
149
150 VAR=$1
151 shift
152 eval VAL=\${${VAR}}
153 for f in ${VAL}; do
154 for x in "$@"; do
155 # Note this should work with globs like -O*
156 [[ ${f} == ${x} ]] && continue 2
157 done
158 eval new\[\${\#new\[@]}]=\${f}
159 done
160 eval export ${VAR}=\${new\[*]}
161 }
162
163 filter-flags() {
164 _filter-hardened "$@"
165 _filter-var CFLAGS "$@"
166 _filter-var CXXFLAGS "$@"
167 return 0
168 }
169
170 filter-lfs-flags() {
171 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments"
172 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
173 }
174
175 append-lfs-flags() {
176 [[ -n $@ ]] && die "append-lfs-flags takes no arguments"
177 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
178 }
179
180 append-flags() {
181 [[ -z $* ]] && return 0
182 export CFLAGS="${CFLAGS} $*"
183 export CXXFLAGS="${CXXFLAGS} $*"
184 return 0
185 }
186
187 replace-flags() {
188 [[ $# != 2 ]] \
189 && echo && eerror "Usage: replace-flags <old flag> <new flag>" \
190 && die "replace-flags takes 2 arguments, not $#"
191
192 local f fset
193 declare -a new_CFLAGS new_CXXFLAGS
194
195 for fset in CFLAGS CXXFLAGS; do
196 # Looping over the flags instead of using a global
197 # substitution ensures that we're working with flag atoms.
198 # Otherwise globs like -O* have the potential to wipe out the
199 # list of flags.
200 for f in ${!fset}; do
201 # Note this should work with globs like -O*
202 [[ ${f} == ${1} ]] && f=${2}
203 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
204 done
205 eval export ${fset}=\${new_${fset}\[*]}
206 done
207
208 return 0
209 }
210
211 replace-cpu-flags() {
212 local newcpu="$#" ; newcpu="${!newcpu}"
213 while [ $# -gt 1 ] ; do
214 # quote to make sure that no globbing is done (particularly on
215 # ${oldcpu} prior to calling replace-flags
216 replace-flags "-march=${1}" "-march=${newcpu}"
217 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}"
218 replace-flags "-mtune=${1}" "-mtune=${newcpu}"
219 shift
220 done
221 return 0
222 }
223
224 is-flagq() {
225 local x
226
227 for x in ${CFLAGS} ${CXXFLAGS} ; do
228 # Note this should work with globs like -mcpu=ultrasparc*
229 if [[ ${x} == ${1} ]]; then
230 return 0
231 fi
232 done
233 return 1
234 }
235
236 is-flag() {
237 if is-flagq ${1}; then
238 echo true
239 return 0
240 fi
241 return 1
242 }
243
244 is-ldflagq() {
245 local x
246
247 for x in ${LDFLAGS} ; do
248 # Note this should work with globs like -mcpu=ultrasparc*
249 if [[ ${x} == ${1} ]]; then
250 return 0
251 fi
252 done
253 return 1
254 }
255
256 is-ldflag() {
257 if is-ldflagq ${1}; then
258 echo true
259 return 0
260 fi
261 return 1
262 }
263
264 filter-mfpmath() {
265 local orig_mfpmath new_math prune_math
266
267 # save the original -mfpmath flag
268 orig_mfpmath="`get-flag -mfpmath`"
269 # get the value of the current -mfpmath flag
270 new_math=" `get-flag mfpmath | tr , ' '` "
271 # figure out which math values are to be removed
272 prune_math=""
273 for prune_math in "$@" ; do
274 new_math="${new_math/ ${prune_math} / }"
275 done
276 new_math="`echo ${new_math:1:${#new_math}-2} | tr ' ' ,`"
277
278 if [ -z "${new_math}" ] ; then
279 # if we're removing all user specified math values are
280 # slated for removal, then we just filter the flag
281 filter-flags ${orig_mfpmath}
282 else
283 # if we only want to filter some of the user specified
284 # math values, then we replace the current flag
285 replace-flags ${orig_mfpmath} -mfpmath=${new_math}
286 fi
287 return 0
288 }
289
290 strip-flags() {
291 local x y flag NEW_CFLAGS NEW_CXXFLAGS
292
293 setup-allowed-flags
294
295 local NEW_CFLAGS=""
296 local NEW_CXXFLAGS=""
297
298 # Allow unstable C[XX]FLAGS if we are using unstable profile ...
299 if has ~$(tc-arch) ${ACCEPT_KEYWORDS} ; then
300 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}"
301 fi
302
303 set -f # disable pathname expansion
304
305 for x in ${CFLAGS}; do
306 for y in ${ALLOWED_FLAGS}; do
307 flag=${x%%=*}
308 if [ "${flag%%${y}}" = "" ] ; then
309 NEW_CFLAGS="${NEW_CFLAGS} ${x}"
310 break
311 fi
312 done
313 done
314
315 for x in ${CXXFLAGS}; do
316 for y in ${ALLOWED_FLAGS}; do
317 flag=${x%%=*}
318 if [ "${flag%%${y}}" = "" ] ; then
319 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}"
320 break
321 fi
322 done
323 done
324
325 # In case we filtered out all optimization flags fallback to -O2
326 if [ "${CFLAGS/-O}" != "${CFLAGS}" -a "${NEW_CFLAGS/-O}" = "${NEW_CFLAGS}" ]; then
327 NEW_CFLAGS="${NEW_CFLAGS} -O2"
328 fi
329 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then
330 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2"
331 fi
332
333 set +f # re-enable pathname expansion
334
335 export CFLAGS="${NEW_CFLAGS}"
336 export CXXFLAGS="${NEW_CXXFLAGS}"
337 return 0
338 }
339
340 test-flag-PROG() {
341 local comp=$1
342 local flags="$2"
343
344 [[ -z ${comp} || -z ${flags} ]] && \
345 return 1
346
347 local PROG=$(tc-get${comp})
348 ${PROG} ${flags} -S -o /dev/null -xc /dev/null \
349 > /dev/null 2>&1
350 }
351
352 # Returns true if C compiler support given flag
353 test-flag-CC() { test-flag-PROG "CC" "$1"; }
354
355 # Returns true if C++ compiler support given flag
356 test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
357
358 test-flags-PROG() {
359 local comp=$1
360 local flags
361 local x
362
363 shift
364
365 [[ -z ${comp} ]] && \
366 return 1
367
368 for x in "$@" ; do
369 test-flag-${comp} "${x}" && flags="${flags} ${x}"
370 done
371
372 echo "${flags}"
373
374 # Just bail if we dont have any flags
375 [[ -n ${flags} ]]
376 }
377
378 # Returns (echo's) the given flags supported by the C compiler
379 test-flags-CC() { test-flags-PROG "CC" "$@"; }
380
381 # Returns (echo's) the given flags supported by the C++ compiler
382 test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
383
384 # Short-hand that should hopefully work for both C and C++ compiler, but
385 # its really only present due to the append-flags() abomination.
386 test-flags() { test-flags-CC "$@"; }
387
388 # Depriciated, use test-flags()
389 test_flag() {
390 ewarn "test_flag: deprecated, please use test-flags()!" >&2
391
392 test-flags-CC "$@"
393 }
394
395 test_version_info() {
396 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
397 return 0
398 else
399 return 1
400 fi
401 }
402
403 strip-unsupported-flags() {
404 local x NEW_CFLAGS NEW_CXXFLAGS
405
406 for x in ${CFLAGS} ; do
407 NEW_CFLAGS="${NEW_CFLAGS} $(test-flags ${x})"
408 done
409 for x in ${CXXFLAGS} ; do
410 NEW_CXXFLAGS="${NEW_CXXFLAGS} $(test-flags ${x})"
411 done
412
413 export CFLAGS=${NEW_CFLAGS}
414 export CXXFLAGS=${NEW_CXXFLAGS}
415 }
416
417 get-flag() {
418 local f findflag="$1"
419
420 # this code looks a little flaky but seems to work for
421 # everything we want ...
422 # for example, if CFLAGS="-march=i686":
423 # `get-flag -march` == "-march=i686"
424 # `get-flag march` == "i686"
425 for f in ${CFLAGS} ${CXXFLAGS} ; do
426 if [ "${f/${findflag}}" != "${f}" ] ; then
427 printf "%s\n" "${f/-${findflag}=}"
428 return 0
429 fi
430 done
431 return 1
432 }
433
434 # DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
435 has_hardened() {
436 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
437
438 test_version_info Hardened && return 0
439 # The specs file wont exist unless gcc has GCC_SPECS support
440 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
441 }
442
443 # DEPRECATED - use gcc-specs-pie from toolchain-funcs
444 # indicate whether PIC is set
445 has_pic() {
446 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
447
448 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
449 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
450 gcc-specs-pie
451 }
452
453 # DEPRECATED - use gcc-specs-pie from toolchain-funcs
454 # indicate whether PIE is set
455 has_pie() {
456 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
457
458 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
459 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
460 gcc-specs-pie
461 }
462
463 # DEPRECATED - use gcc-specs-ssp from toolchain-funcs
464 # indicate whether code for SSP is being generated for all functions
465 has_ssp_all() {
466 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
467
468 # note; this matches only -fstack-protector-all
469 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
470 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
471 gcc-specs-ssp-all
472 }
473
474 # DEPRECATED - use gcc-specs-ssp from toolchain-funcs
475 # indicate whether code for SSP is being generated
476 has_ssp() {
477 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
478
479 # note; this matches both -fstack-protector and -fstack-protector-all
480 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
481 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
482 gcc-specs-ssp
483 }
484
485 has_m64() {
486 # this doesnt test if the flag is accepted, it tests if the flag
487 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
488 # please dont replace this function with test_flag in some future
489 # clean-up!
490
491 local temp="$(emktemp)"
492 echo "int main() { return(0); }" > "${temp}".c
493 MY_CC=$(tc-getCC)
494 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
495 local ret=$?
496 rm -f "${temp}".c
497 [[ ${ret} != 1 ]] && return 0
498 return 1
499 }
500
501 has_m32() {
502 # this doesnt test if the flag is accepted, it tests if the flag
503 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
504 # please dont replace this function with test_flag in some future
505 # clean-up!
506
507 [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
508
509 local temp=$(emktemp)
510 echo "int main() { return(0); }" > "${temp}".c
511 MY_CC=$(tc-getCC)
512 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
513 local ret=$?
514 rm -f "${temp}".c
515 [[ ${ret} != 1 ]] && return 0
516 return 1
517 }
518
519 replace-sparc64-flags() {
520 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
521
522 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
523 for x in ${SPARC64_CPUS}; do
524 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}"
525 done
526 else
527 for x in ${SPARC64_CPUS}; do
528 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
529 done
530 fi
531
532 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then
533 for x in ${SPARC64_CPUS}; do
534 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}"
535 done
536 else
537 for x in ${SPARC64_CPUS}; do
538 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
539 done
540 fi
541
542 export CFLAGS CXXFLAGS
543 }
544
545 append-ldflags() {
546 [[ -z $* ]] && return 0
547 export LDFLAGS="${LDFLAGS} $*"
548 return 0
549 }
550
551 # Remove flags from LDFLAGS - it's up to the ebuild to filter
552 # CFLAGS and CXXFLAGS via filter-flags if they need to.
553 filter-ldflags() {
554 _filter-var LDFLAGS "$@"
555 return 0
556 }
557
558 # Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
559 # are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
560 # to gcc where it needs the '-Wl,'.
561 raw-ldflags() {
562 local x input="$@"
563 [[ -z ${input} ]] && input=${LDFLAGS}
564 set --
565 for x in ${input} ; do
566 x=${x#-Wl,}
567 set -- "$@" ${x//,/ }
568 done
569 echo "$@"
570 }
571
572 # This is thanks to great work from Paul de Vrieze <gentoo-user@devrieze.net>,
573 # bug #9016. Also thanks to Jukka Salmi <salmi@gmx.net> (bug #13907) for more
574 # fixes.
575 #
576 # Export CFLAGS and CXXFLAGS that are compadible with gcc-2.95.3
577 gcc2-flags() {
578 if [[ $(tc-arch) == "x86" || $(tc-arch) == "amd64" ]] ; then
579 CFLAGS=${CFLAGS//-mtune=/-mcpu=}
580 CXXFLAGS=${CXXFLAGS//-mtune=/-mcpu=}
581 fi
582
583 replace-cpu-flags k6-{2,3} k6
584 replace-cpu-flags athlon{,-{tbird,4,xp,mp}} i686
585
586 replace-cpu-flags pentium-mmx i586
587 replace-cpu-flags pentium{2,3,4} i686
588
589 replace-cpu-flags ev6{7,8} ev6
590
591 export CFLAGS CXXFLAGS
592 }
593
594 # Gets the flags needed for "NOW" binding
595 bindnow-flags() {
596 case $($(tc-getLD) -v 2>&1 </dev/null) in
597 *GNU* | *'with BFD'*) # GNU ld
598 echo "-Wl,-z,now" ;;
599 *Apple*) # Darwin ld
600 echo "-bind_at_load" ;;
601 *)
602 # Some linkers just recognize -V instead of -v
603 case $($(tc-getLD) -V 2>&1 </dev/null) in
604 *Solaris*) # Solaris accept almost the same GNU options
605 echo "-Wl,-z,now" ;;
606 esac
607 ;;
608 esac
609 }

  ViewVC Help
Powered by ViewVC 1.1.20